import random

class Compteur:
    
    def __init__(self): self.count = 0
    
    def incr(self): self.count += 1
        
    def reset(self): self.count = 0
        
    def __repr__(self):
        return 'comparaisons : %d' % (self.count)

CG = Compteur()

def inferieur(x, y):
    CG.incr()
    return x <= y

def echanger(s, i, j):
    s[i], s[j] = s[j], s[i]


def liste_aleatoire(n):
    s = list(range(n))
    for i in range(n):
        j = random.randint(i, n - 1)
        echanger(s, i, j)
    return s

def stats(algo, step=1, min=1, max =100, sample=1):
    tailles = list(range(min, max+step, step))
    tcomp = []
    for k in tailles:
        vcomp = 0
        for j in range(sample):
            s = liste_aleatoire(k)
            CG.reset()
            algo(s)
            vcomp += CG.count
        tcomp.append(vcomp / sample)
    return (tailles, tcomp)


def partition(s, l, r):
    echanger(s, random.randint(l, r), r)
    i = l - 1
    for j in range(l, r):
        if inferieur(s[j], s[r]):
            i = i + 1
            echanger(s, i, j)
    echanger(s, i + 1, r)
    return i + 1

def tri_aux(s, l, r):
    if l <= r:
        q = partition(s, l, r)
        tri_aux(s, l, q - 1)
        tri_aux(s, q + 1, r)
        
def quicksort(s):
    tri_aux(s, 0, len(s) - 1)